package com.loafle.overflow.central.module.generator.service;

import com.loafle.overflow.model.auth.AuthCrawler;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.infra.InfraHost;
import com.loafle.overflow.model.meta.MetaSensorItemKey;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.sensor.SensorItem;
import com.loafle.overflow.model.sensorconfig.Connection;
import com.loafle.overflow.model.sensorconfig.Crawler;
import com.loafle.overflow.model.sensorconfig.Schedule;
import com.loafle.overflow.model.sensorconfig.SensorConfig;
import com.loafle.overflow.model.sensorconfig.Target;

import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.type.TypeReference;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by snoop on 17. 9. 6.
 */
@Service("InfraHostGenerator")
public class InfraHostGenerator {

  @Autowired
  private GenerateUtil generateUtil;

  @Autowired
  private InfraHostWMIGenerator infraHostWMIGenerator;

  @Autowired
  private ObjectMapper objectMapper;

  public String process(Sensor dbSensor, List<SensorItem> sensorItems, Infra infra) throws Exception {

    InfraHost infraHost = (InfraHost) infra;

    SensorConfig sensorConfig = new SensorConfig();
    sensorConfig.setConfigID(String.valueOf(dbSensor.getId()));

    Target target = this.createTarget(infraHost, dbSensor);

    if (target == null) {
      return null;
    }

    sensorConfig.setTarget(target);

    // FIXME: Interval
    Schedule schedule = new Schedule();
    schedule.setInterval("5");
    sensorConfig.setSchedule(schedule);

    Crawler crawler = this.generateUtil.getCrawler(dbSensor.getMetaCrawler());
    sensorConfig.setCrawler(crawler);

    Map<Integer, MetaSensorItemKey> keyMap = this.generateUtil.initMappingMap(dbSensor.getMetaCrawler());

    // if (dbSensor.getMetaCrawler().getId() == MetaCrawlerEnum.WMI_CRAWLER.getValue()) {
    //   this.infraHostWMIGenerator.process(sensorItems, keyMap, dbSensor, sensorConfig);
    // }

    return objectMapper.writeValueAsString(sensorConfig);
  }

  private Target createTarget(InfraHost infraHost, Sensor dbSensor) throws Exception {

    // AuthCrawler authCrawler = this.authCrawlerService.readByMetaCrawlerIDAndTargetID(dbSensor.getMetaCrawler().getId(),
    //     dbSensor.getTarget().getId());

    // if (authCrawler == null) {
    //   return null;
    // }

    // Target target = new Target();
    // Connection connection = new Connection();
    // // connection.setIp(infraHost.getIpv4());

    // HashMap<String, String> optionMap = this.objectMapper.readValue(authCrawler.getAuthJson(),
    //     new TypeReference<Map<String, String>>() {
    //     });

    // if (dbSensor.getMetaCrawler().getId() == MetaCrawlerEnum.WMI_CRAWLER.getValue()) {
    //   connection.setPort(135);
    //   connection.setPortType(PortType.TCP);
    //   connection.setSsl(false);

    //   target.setConnection(connection);

    //   Map<String, Object> auth = new HashMap<>();
    //   auth.put("id", optionMap.get("ID"));
    //   auth.put("pw", optionMap.get("PassWord"));

    //   target.setAuth(auth);

    // }

    return null;
  }
}
