package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaCryptoTypeDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaCryptoType;
import com.loafle.overflow.service.central.meta.MetaCryptoTypeService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 7. 27.
 */
@Service("MetaCryptoTypeService")
public class CentralMetaCryptoTypeService implements MetaCryptoTypeService {
  @Autowired
  private MetaCryptoTypeDAO metaCryptoTypeDAO;

  @Override
  public MetaCryptoType regist(MetaCryptoType metaCryptoType) throws OverflowException {
    return this.metaCryptoTypeDAO.save(metaCryptoType);
  }

  @Override
  public MetaCryptoType readByKey(String key) throws OverflowException {
    return this.metaCryptoTypeDAO.findByKey(key);
  }

  @Override
  public List<MetaCryptoType> readAll() throws OverflowException {
    return this.metaCryptoTypeDAO.findAll();
  }
}
