package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaTargetTypeDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaTargetType;
import com.loafle.overflow.service.central.meta.MetaTargetTypeService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 7. 27.
 */
@Service("MetaTargetTypeService")
public class CentralMetaTargetTypeService implements MetaTargetTypeService {

  @Autowired
  private MetaTargetTypeDAO metaTargetTypeDAO;

  @Override
  public MetaTargetType regist(MetaTargetType metaTargetType) throws OverflowException {
    return this.metaTargetTypeDAO.save(metaTargetType);
  }

  @Override
  public MetaTargetType readByKey(String key) throws OverflowException {
    return this.metaTargetTypeDAO.findByKey(key);
  }

  @Override
  public List<MetaTargetType> readAll() throws OverflowException {
    return this.metaTargetTypeDAO.findAll();
  }
}
